import QtQuick 1.0
import org.kde.plasma.core 0.1 as PlasmaCore
import org.kde.plasma.graphicswidgets 0.1 as PlasmaWidgets
import org.kde.plasma.graphicslayouts 4.7 as GraphicsLayouts
import org.kde.plasma.components 0.1 as PlasmaComponents

  

Item{
	id: item
	property string tempStr:i18n("Temperature: ")
	property string memoryStr:i18n("Memory: ")

	function calculateMinWidth(){
		item.width = Math.max(temp.paintedWidth, memory.paintedWidth);
	}


	PlasmaCore.DataSource {
		id: dataSource
		engine: "nvidiaDeviceMonitorEngine"
		connectedSources: ["gpu0"]
		interval: 2000
		onDataChanged: {
			temp.text = item.tempStr+" "+dataSource.data["gpu0"]["gpu_temp"];
			memory.text= item.memoryStr+dataSource.data["gpu0"]["memory_used"]+" / "+dataSource.data["gpu0"]["memory_total"];
			device.text=dataSource.data["gpu0"]["product_name"];
			
			
		}
	}
	PlasmaCore.Theme{
		id: tema
	}

	Component.onCompleted:{
		
		plasmoid.setPreferredSize(270,90);
		plasmoid.setMinimumSize(256,64);
		plasmoid.aspectRatioMode=IgnoreAspectRatio;
		
		
	}
	Item{
		id:item2
		
		anchors{
			fill :parent;
		}
		Item{
			id:iconContainer
			width: item.width/3;
			height: Math.min(item.width/3, item.height);
			anchors {
				//verticalCenter: parent.verticalCenter;
				//horizontalCenter: parent.horizontalCenter;
				top: parent.top;
				bottom: parent.bottom;
				left: parent.left;
				//right: columnContainer.left
				//right:columnContainer.left;
			}
			Image {
				id: icon
				
				fillMode: Image.PreserveAspectFit
				smooth: true
				source: "plasmapackage:/images/nvidia_logo2.png"
				anchors {
					fill:parent
					verticalCenter: parent.verticalCenter;
					horizontalCenter: parent.horizontalCenter;
					//top: parent.top;
					//bottom: parent.bottom;
					//left: parent.left;
					//right:parent.right;
				}      
			}
		}
		Item{
			id:columnContainer
			width: 2*item.width/3;
			height: iconContainer.height
			anchors {
				//verticalCenter: parent.verticalCenter;
				//horizontalCenter: parent.horizontalCenter;
				top: parent.top;
				bottom: parent.bottom;
				right: parent.right;
				//left: iconContainer.right;
			}
			Column{
				id: textContainer
				spacing:0
				anchors { 
					verticalCenter: parent.verticalCenter;
					horizontalCenter: parent.horizontalCenter;
					//left: icon.right;
					//right: parent.right;	
					//leftMargin:4;
				}
		
				PlasmaComponents.Label {
					id: device
					font.italic:!(tema.defaultFont.italic)
					text: i18n("Device: ")
					verticalAlignment : Text.AlignVCenter
					horizontalAlignment : Text.AlignLeft
					height:device.paintedHeight
				}
		
				PlasmaComponents.Label {
					id: temp
					text: "Temperature: "
					verticalAlignment : Text.AlignVCenter
					horizontalAlignment : Text.AlignLeft
					height:temp.paintedHeight
				}
				PlasmaComponents.Label {
					id: memory
					text: i18n("Memory: ")
					verticalAlignment : Text.AlignVCenter
					horizontalAlignment : Text.AlignLeft
					height:memory.paintedHeight
				}
			}
		}
	}

}
